import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Main {
  public static void main(String[] a) throws Exception {
    JPAUtil util = new JPAUtil();

    EntityManagerFactory emf = Persistence.createEntityManagerFactory("ProfessorService");
    EntityManager em = emf.createEntityManager();
    ProfessorService service = new ProfessorService(em);

    em.getTransaction().begin();
    Professor emp = service.createProfessor("empName", 100);
    ParkingSpace pSpace = service.createParkingSpace(1, "location");
    Professor emp1 = service.setProfessorParkingSpace(emp.getId(), pSpace.getId());

    Collection<Professor> emps = service.findAllProfessors();
    if (emps.isEmpty()) {
      System.out.println("No Professors found ");
    } else {
      System.out.println("Found Professors: ");
      for (Professor emp2 : emps) {
        System.out.println(emp2);
      }
    }

    Collection<ParkingSpace> pSpaces = service.findAllParkingSpaces();
    if (pSpaces.isEmpty()) {
      System.out.println("No ParkingSpaces found ");
    } else {
      System.out.println("Found ParkingSpaces:");
      for (ParkingSpace pSpace1 : pSpaces) {
        System.out.println(pSpace1);
      }
    }

    util.checkData("select * from Professor");
    util.checkData("select * from ParkingSpace");

    em.getTransaction().commit();
    em.close();
    emf.close();
  }
}