import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String name, long salary) {
    Professor emp = new Professor();
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Professor setProfessorParkingSpace(int empId, int spaceId) {
    Professor emp = em.find(Professor.class, empId);
    ParkingSpace pSpace = em.find(ParkingSpace.class, spaceId);
    emp.setParkingSpace(pSpace);
    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

  public ParkingSpace createParkingSpace(int lot, String location) {
    ParkingSpace space = new ParkingSpace();
    space.setLot(lot);
    space.setLocation(location);
    em.persist(space);

    return space;
  }

  public Collection<ParkingSpace> findAllParkingSpaces() {
    Query query = em.createQuery("SELECT p FROM ParkingSpace p");
    return (Collection<ParkingSpace>) query.getResultList();
  }
}
